#import <Cocoa/Cocoa.h>

#include <Foundation/Foundation.h>
#include <AppKit/AppKit.h>

static NSWindow *window = NULL;

int cocoaInit() {
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	NSApp = [NSApplication sharedApplication];
	NSApplicationLoad();
//	MyDelegate *delegate = [[MyDelegate alloc] init];
//	[NSApp setDelegate:delegate];
	return 0;
}


CGLContextObj cocoaCreateWindow(float x, float y, float w, float h) {
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

	{
		NSRect rect;
		rect.size.width = w;
		rect.size.height = h;
		rect.origin.x = x;
		rect.origin.y = y;

		window = [[NSWindow alloc]
			initWithContentRect:rect
			styleMask:NSTitledWindowMask | NSClosableWindowMask | NSMiniaturizableWindowMask | NSResizableWindowMask
			backing:NSBackingStoreBuffered
			defer:NO];

		int winID = [window windowNumber];
		CGSSetWindowLevel(_CGSDefaultConnection(), winID, CGShieldingWindowLevel()+1);
			
//		CGSOrderWindow(_CGSDefaultConnection(), winID, kCGSOrderAbove, 0);
		
		CGContextRef ctx = (CGContextRef)CGWindowContextCreate(_CGSDefaultConnection(), winID, NULL);
		
		CGContextClear(ctx);
		CGContextFlush(ctx);
		CGContextRelease(ctx);
	}

	NSOpenGLPixelFormatAttribute attributes[] = { 
		//NSOpenGLPFAAccelerated,
		//NSOpenGLPFADepthSize, 16,
		//NSOpenGLPFAMinimumPolicy,
		//NSOpenGLPFAClosestPolicy,
		//0

		NSOpenGLPFAColorSize, (NSOpenGLPixelFormatAttribute)32,
		NSOpenGLPFAAlphaSize, (NSOpenGLPixelFormatAttribute)8,
		NSOpenGLPFADepthSize, (NSOpenGLPixelFormatAttribute)32,
		NSOpenGLPFAStencilSize, (NSOpenGLPixelFormatAttribute)8,
		//NSOpenGLPFASampleBuffers, (NSOpenGLPixelFormatAttribute)0,
		//NSOpenGLPFASamples, (NSOpenGLPixelFormatAttribute)0,
		//NSOpenGLPFAScreenMask, (NSOpenGLPixelFormatAttribute)CGDisplayIDToOpenGLDisplayMask(kCGDirectMainDisplay),
		//NSOpenGLPFAFullScreen,
		NSOpenGLPFADoubleBuffer,
		NSOpenGLPFAAccelerated,
		//NSOpenGLPFAAllRenderers,
		(NSOpenGLPixelFormatAttribute)0
	};
	
	NSOpenGLPixelFormat *format = [[[NSOpenGLPixelFormat alloc] initWithAttributes:attributes] autorelease];

	NSRect rect;
	rect.origin.x = 0;
	rect.origin.y = 0;
	rect.size.width = w;
	rect.size.height = h;
		
	NSOpenGLView *view = [[NSOpenGLView alloc] initWithFrame:rect pixelFormat:format];
		
	[window setContentView:view];
	[window makeFirstResponder:view];

	NSOpenGLContext *ctx = [view openGLContext];
	[ctx makeCurrentContext];
	
	return [ctx CGLContextObj];
}

WindowRef cocoaGetWindowRef() {
	return [window windowRef];
}

int cocoaShutdown() {
	if (!window) return 1;
	
	//TODO - destroy context and all else
	
	return 0;
}